/*************************************************************************
 *
 *  $RCSfile: sc_cbuttonw.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:38:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

#include <tools/svwin.h>
#include <vcl/window.hxx>
// auto strip #include <vcl/decoview.hxx>
// auto strip #include <vcl/svapp.hxx>

#include "cbutton.hxx"
namespace binfilter {


//========================================================================
//	class ScDDComboBoxButton
//========================================================================

/*N*/ ScDDComboBoxButton::ScDDComboBoxButton( Window* pOutputDevice )
/*N*/ 	:	pOut( pOutputDevice )
/*N*/ {
/*N*/ 	SetOptSizePixel();
/*N*/ }

// -------------------------------------------------------------------------

/*N*/ __EXPORT ScDDComboBoxButton::~ScDDComboBoxButton()
/*N*/ {
/*N*/ }

// -------------------------------------------------------------------------

/*N*/ void ScDDComboBoxButton::SetOptSizePixel()
/*N*/ {
/*N*/ 	aBtnSize = pOut->LogicToPixel( Size(0,11), MAP_APPFONT );
/*N*/ 	//aBtnSize.Width() = GetSystemMetrics( SM_CXVSCROLL ) - 1; // Win SDK-Funktion
/*N*/ 	aBtnSize.Width() = pOut->GetSettings().GetStyleSettings().GetScrollBarSize();
/*N*/ }

// -------------------------------------------------------------------------

//STRIP001 void ScDDComboBoxButton::Draw( const Point&	rAt,
//STRIP001 							   const Size&	rSize,
//STRIP001                                BOOL         bState,
//STRIP001 							   BOOL			bBtnIn  /* = FALSE */ )
//STRIP001 {
//STRIP001 	// save old state
//STRIP001 	BOOL		bHadFill   = pOut->IsFillColor();
//STRIP001 	Color		aOldFill   = pOut->GetFillColor();
//STRIP001 	BOOL		bHadLine   = pOut->IsLineColor();
//STRIP001 	Color		aOldLine   = pOut->GetLineColor();
//STRIP001 	BOOL		bOldEnable = pOut->IsMapModeEnabled();
//STRIP001 
//STRIP001 	Size		aLogPix( 1, 1 );
//STRIP001 	Rectangle	aBtnRect( rAt, rSize );
//STRIP001 	Rectangle	aInnerRect = aBtnRect;
//STRIP001 
//STRIP001 	pOut->EnableMapMode( FALSE );
//STRIP001 
//STRIP001 	DecorationView aDecoView( pOut);
//STRIP001 
//STRIP001 	USHORT nButtonStyle = BUTTON_DRAW_DEFAULT;
//STRIP001 	if( bBtnIn )	// gedrueckt?
//STRIP001 	{
//STRIP001 		nButtonStyle = BUTTON_DRAW_PRESSED;
//STRIP001 	}
//STRIP001 
//STRIP001 	aInnerRect=aDecoView.DrawButton( aBtnRect, nButtonStyle );
//STRIP001 
//STRIP001 
//STRIP001 	aInnerRect.Left()   += 1;
//STRIP001 	aInnerRect.Top()    += 1;
//STRIP001 	aInnerRect.Right()  -= 1;
//STRIP001 	aInnerRect.Bottom() -= 1;
//STRIP001 
//STRIP001 	Size  aInnerSize   = aInnerRect.GetSize();
//STRIP001 	Point aInnerCenter = aInnerRect.Center();
//STRIP001 
//STRIP001 	aInnerRect.Top()   = aInnerCenter.Y() - (aInnerSize.Width()>>1);
//STRIP001 	aInnerRect.Bottom()= aInnerCenter.Y() + (aInnerSize.Width()>>1);
//STRIP001 
//STRIP001     ImpDrawArrow( aInnerRect, bState );
//STRIP001 
//STRIP001 
//STRIP001 	// restore old state
//STRIP001 	pOut->EnableMapMode( bOldEnable );
//STRIP001 	if (bHadLine)
//STRIP001 		pOut->SetLineColor(aOldLine);
//STRIP001 	else
//STRIP001 		pOut->SetLineColor();
//STRIP001 	if (bHadFill)
//STRIP001 		pOut->SetFillColor(aOldFill);
//STRIP001 	else
//STRIP001 		pOut->SetFillColor();
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 void ScDDComboBoxButton::ImpDrawArrow( const Rectangle& rRect,
//STRIP001                                        BOOL             bState )
//STRIP001 {
//STRIP001 	// no need to save old line and fill color here (is restored after the call)
//STRIP001 
//STRIP001 	Rectangle	aPixRect = rRect;
//STRIP001 	Point		aCenter  = aPixRect.Center();
//STRIP001 	Size      	aSize    = aPixRect.GetSize();
//STRIP001 
//STRIP001 	Size aSize3;
//STRIP001 	aSize3.Width() = aSize.Width() >> 1;
//STRIP001 	aSize3.Height() = aSize.Height() >> 1;
//STRIP001 
//STRIP001 	Size aSize4;
//STRIP001 	aSize4.Width() = aSize.Width() >> 2;
//STRIP001 	aSize4.Height() = aSize.Height() >> 2;
//STRIP001 
//STRIP001 	Rectangle aTempRect = aPixRect;
//STRIP001 
//STRIP001     const StyleSettings& rSett = Application::GetSettings().GetStyleSettings();
//STRIP001     Color aColor( bState ? COL_LIGHTBLUE : rSett.GetButtonTextColor().GetColor() );
//STRIP001     pOut->SetFillColor( aColor );
//STRIP001     pOut->SetLineColor( aColor );
//STRIP001 
//STRIP001 	aTempRect.Left()   = aCenter.X() - aSize4.Width();
//STRIP001 	aTempRect.Right()  = aCenter.X() + aSize4.Width();
//STRIP001 	aTempRect.Top()    = aCenter.Y() - aSize3.Height();
//STRIP001 	aTempRect.Bottom() = aCenter.Y() - 1;
//STRIP001 
//STRIP001 	pOut->DrawRect( aTempRect );
//STRIP001 
//STRIP001 	Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y() );
//STRIP001 	Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y() );
//STRIP001 	while( aPos1.X() <= aPos2.X() )
//STRIP001 	{
//STRIP001 		pOut->DrawLine( aPos1, aPos2 );
//STRIP001 		aPos1.X()++; aPos2.X()--;
//STRIP001 		aPos1.Y()++; aPos2.Y()++;
//STRIP001 	}
//STRIP001 
//STRIP001 	pOut->DrawLine( Point( aCenter.X() - aSize3.Width(), aPos1.Y()+1 ),
//STRIP001 					Point( aCenter.X() + aSize3.Width(), aPos1.Y()+1 ) );
//STRIP001 }





}
