/*************************************************************************
 *
 *  $RCSfile: fusel.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:36:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_FUSEL_HXX
#define _SD_FUSEL_HXX

#ifndef _SD_FUDRAW_HXX
#include "fudraw.hxx"
#endif
class Sound;
namespace binfilter {

class SdrHdl;
class SdrObject;


/*************************************************************************
|*
|* Basisklasse fuer alle Funktionen
|*
\************************************************************************/

class FuSelection : public FuDraw
{
 protected:
	BOOL			bTempRotation;
	BOOL            bSelectionChanged;
	BOOL            bHideAndAnimate;
	SdrHdl*         pHdl;
	BOOL            bSuppressChangesOfSelection;
	BOOL            bMirrorSide0;
	USHORT          nEditMode;
	Sound*          pSound;

//STRIP001 					DECL_LINK( SoundHasStoppedHdl, void* );
					DECL_STATIC_LINK( FuSelection, StaticSoundHasStoppedHdl, Sound* );

 public:
	TYPEINFO();

	FuSelection(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
				SdDrawDocument* pDoc, SfxRequest& rReq);

	virtual ~FuSelection();
									   // Mouse- & Key-Events
//STRIP001 	virtual BOOL KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual BOOL MouseMove(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL MouseButtonUp(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL MouseButtonDown(const MouseEvent& rMEvt);

	virtual void Activate();		   // Function aktivieren
	virtual void Deactivate();		   // Function deaktivieren

	virtual void SelectionHasChanged();

//STRIP001 	void    SetEditMode(USHORT nMode);
	USHORT  GetEditMode() { return nEditMode; }

//STRIP001 	BOOL	AnimateObj(SdrObject* pObj, const Point& rPos);

	/** is called when the currenct function should be aborted. <p>
		This is used when a function gets a KEY_ESCAPE but can also
		be called directly.

		@returns true if a active function was aborted
	*/
//STRIP001 	virtual bool cancel();

private:
    /** This pointer stores a canidate for assigning a style in the water
        can mode between mouse button down and mouse button up.
    */
    SdrObject* pWaterCanCandidate;

    /** Find the object under the given test point without selecting it.
        @param rTestPoint
            The coordinates at which to search for a shape.
        @return
            The shape at the test point.  When there is no shape at this
            position then NULL is returned.
    */
    SdrObject* pickObject (const Point& rTestPoint);
};



} //namespace binfilter
#endif		// _SD_FUSEL_HXX

