/*************************************************************************
 *
 *  $RCSfile: sd_grstdob.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:37:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif

#pragma hdrstop

#include "res_bmp.hrc"
#include "glob.hrc"

#include "docshell.hxx"
#include "viewshel.hxx"
#include "drawview.hxx"
#include "grstdob.hxx"
#include "sdresid.hxx"
namespace binfilter {



/*************************************************************************
|*
|* Standardinterface deklarieren (Die Slotmap darf nicht leer sein, also
|* tragen wir etwas ein, was hier (hoffentlich) nie vorkommt).
|*
\************************************************************************/

#define ShellClass SdGraphicStdObjectBar


SFX_SLOTMAP(SdGraphicStdObjectBar)
{
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};


/*N*/ SFX_IMPL_INTERFACE(SdGraphicStdObjectBar, SfxShell, SdResId(STR_STDOBJECTBARSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_GRAPHIC_OBJ_TOOLBOX) );
/*N*/ }

TYPEINIT1( SdGraphicStdObjectBar, SfxShell );


/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

/*N*/ SdGraphicStdObjectBar::SdGraphicStdObjectBar(SdViewShell* pSdViewShell,
/*N*/ 									   SdView* pSdView) :
/*N*/ 	SfxShell(pSdViewShell)
/*N*/ {
/*N*/ 	SdDrawDocShell* pDocShell = pSdViewShell->GetDocSh();
/*N*/ 	SetPool(&pDocShell->GetPool());
/*N*/ 	SetUndoManager(pDocShell->GetUndoManager());
/*N*/ 	SetRepeatTarget(pSdView);
/*N*/ 
/*N*/ 	SetName( String( RTL_CONSTASCII_USTRINGPARAM( "SdGraphicStdObjectBar" )));
/*N*/ }


/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ SdGraphicStdObjectBar::~SdGraphicStdObjectBar()
/*N*/ {
/*N*/ 	SetRepeatTarget(NULL);
/*N*/ }



}
