/*************************************************************************
 *
 *  $RCSfile: sw_swwait.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen wg. SfxViewFrame
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen wg. SfxDispatcher
#include <bf_sfx2/dispatch.hxx>
#endif
#ifndef _WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif
#ifndef _SWDOCSH_HXX //autogen wg. SwDocShell
#include <docsh.hxx>
#endif
#ifndef _SWWAIT_HXX
#include <swwait.hxx>
#endif
namespace binfilter {


/*N*/ void SwDocShell::EnterWait( BOOL bLockDispatcher )
/*N*/ {
/*N*/ 	SfxViewFrame *pFrame = SfxViewFrame::GetFirst( this, 0, FALSE );
/*N*/ 	while ( pFrame )
/*N*/ 	{
/*N*/ 		pFrame->GetWindow().EnterWait();
/*N*/ 		if ( bLockDispatcher )
/*N*/ 			pFrame->GetDispatcher()->Lock( TRUE );
/*N*/ 		pFrame = SfxViewFrame::GetNext( *pFrame, this, 0, FALSE );
/*N*/ 	}
/*N*/ }

/*N*/ void SwDocShell::LeaveWait( BOOL bLockDispatcher )
/*N*/ {
/*N*/ 	SfxViewFrame *pFrame = SfxViewFrame::GetFirst( this, 0, FALSE );
/*N*/ 	while ( pFrame )
/*N*/ 	{
/*N*/ 		pFrame->GetWindow().LeaveWait();
/*N*/ 		if ( bLockDispatcher )
/*N*/ 			pFrame->GetDispatcher()->Lock( FALSE );
/*N*/ 		pFrame = SfxViewFrame::GetNext( *pFrame, this, 0, FALSE );
/*N*/ 	}
/*N*/ }

/*N*/ SwWait::SwWait( SwDocShell &rDocShell, BOOL bLockDispatcher ) :
/*N*/ 	rDoc ( rDocShell ),
/*N*/ 	bLock( bLockDispatcher )
/*N*/ {
/*N*/ 	rDoc.EnterWait( bLock );
/*N*/ }

/*N*/ SwWait::~SwWait()
/*N*/ {
/*N*/ 	rDoc.LeaveWait( bLock );
/*N*/ }


}
