/*************************************************************************
 *
 *  $RCSfile: basedlgs.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:26:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BASEDLGS_HXX
#define _BASEDLGS_HXX

// include ---------------------------------------------------------------

#ifndef _FLOATWIN_HXX //autogen
#include <vcl/floatwin.hxx>
#endif
#ifndef _TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
class SfxItemSet;
class SfxItemPool;
class OKButton;
class CancelButton;
class HelpButton;
class Button;
namespace binfilter {

class SfxTabPage;
class SfxViewFrame;
class SfxBindings;
class SfxChildWindow;
struct SfxChildWinInfo;

// class SfxModalDefParentHelper -----------------------------------------

//STRIP001 class SfxModalDefParentHelper
//STRIP001 {
//STRIP001 private:
//STRIP001 	Window *pOld;
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxModalDefParentHelper(Window* pWindow);
//STRIP001 	~SfxModalDefParentHelper();
//STRIP001 };

// class SfxModalDialog --------------------------------------------------

class SfxModalDialog: public ModalDialog
{
	SfxViewFrame*		pFrame;
	USHORT				nUniqId;
	String              aExtraData;
	Timer				aTimer;

//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK(			TimerHdl_Impl, Timer* );
//STRIP001 #endif
//STRIP001 
protected:
	SfxModalDialog(SfxViewFrame *pViewFrame, Window *pParent, const ResId &);
	SfxModalDialog(SfxViewFrame *pViewFrame, Window* pParent,
				   USHORT nUniqueId, WinBits nWinStyle = WB_STDMODAL);
	SfxModalDialog(Window *pParent, const ResId &);
	SfxModalDialog(Window* pParent, USHORT nUniqueId,
				   WinBits nWinStyle = WB_STDMODAL);
//STRIP001 	~SfxModalDialog();
//STRIP001 
//STRIP001 	String& 	GetExtraData()		{ return aExtraData; }
//STRIP001 	USHORT		GetUniqId() const	{ return nUniqId; }
};

// class SfxModelessDialog --------------------------------------------------
class SfxModelessDialog_Impl;
class SfxModelessDialog: public ModelessDialog
{
	SfxBindings*			pBindings;
	Size					aSize;
    SfxModelessDialog_Impl* pImp;

protected:
							SfxModelessDialog( SfxBindings*, SfxChildWindow*,
								Window*, const ResId& );
							SfxModelessDialog( SfxBindings*, SfxChildWindow*,
								Window*, WinBits nWinStyle = WB_STDMODELESS );
							~SfxModelessDialog();
//STRIP001 	virtual BOOL			Close();
//STRIP001 	virtual void			Resize();
//STRIP001     virtual void            Move();
//STRIP001     virtual void            StateChanged( StateChangedType nStateChange );

public:
	virtual void        	FillInfo(SfxChildWinInfo&) const;
//STRIP001 	void					Initialize (SfxChildWinInfo* pInfo);
//STRIP001 	virtual long			Notify( NotifyEvent& rNEvt );
//STRIP001     SfxBindings&            GetBindings()
//STRIP001                             { return *pBindings; }
};

// class SfxFloatingWindow --------------------------------------------------
class SfxFloatingWindow_Impl;
class SfxFloatingWindow: public FloatingWindow
{
	SfxBindings*			pBindings;
	Size					aSize;
    SfxFloatingWindow_Impl* pImp;

protected:
//STRIP001 							SfxFloatingWindow( SfxBindings *pBindings,
//STRIP001 											  SfxChildWindow *pCW,
//STRIP001 											  Window* pParent,
//STRIP001 											  WinBits nWinBits=WB_STDMODELESS);
							SfxFloatingWindow( SfxBindings *pBindings,
											  SfxChildWindow *pCW,
											  Window* pParent,
											  const ResId& rResId);
							~SfxFloatingWindow();

    virtual void            StateChanged( StateChangedType nStateChange );
	virtual BOOL			Close();
	virtual void			Resize();
    virtual void            Move();
	virtual long			Notify( NotifyEvent& rNEvt );
    SfxBindings&            GetBindings()
                            { return *pBindings; }

public:
	virtual void        	FillInfo(SfxChildWinInfo&) const;
//STRIP001 	void					Initialize (SfxChildWinInfo* pInfo);
};

// class SfxSingleTabDialog --------------------------------------------------

typedef USHORT*	(*GetTabPageRanges)(); // liefert internationale Which-Werte

//STRIP001 class SfxSingleTabDialog : public SfxModalDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 #if SUPD < 637
//STRIP001 	SfxSingleTabDialog( SfxViewFrame* pViewFrame, Window* pParent,
//STRIP001 						const SfxItemSet& rOptionsSet, USHORT nUniqueId,
//STRIP001 						BOOL bGroupBox = FALSE );
//STRIP001 	SfxSingleTabDialog( Window* pParent, const SfxItemSet& rOptionsSet,
//STRIP001 						USHORT nUniqueId, BOOL bGroupBox = FALSE );
//STRIP001 	SfxSingleTabDialog( SfxViewFrame* pViewFrame, Window* pParent,
//STRIP001 						USHORT nUniqueId,	const SfxItemSet* pInSet = 0,
//STRIP001 						BOOL bGroupBox = FALSE );
//STRIP001 	SfxSingleTabDialog( Window* pParent, USHORT nUniqueId,
//STRIP001 						const SfxItemSet* pInSet = 0,
//STRIP001 						BOOL bGroupBox = FALSE );
//STRIP001 #else
//STRIP001 	SfxSingleTabDialog( SfxViewFrame* pViewFrame, Window* pParent,
//STRIP001 						const SfxItemSet& rOptionsSet, USHORT nUniqueId );
//STRIP001 	SfxSingleTabDialog( Window* pParent, const SfxItemSet& rOptionsSet, USHORT nUniqueId );
//STRIP001 	SfxSingleTabDialog( SfxViewFrame* pViewFrame, Window* pParent,
//STRIP001 						USHORT nUniqueId,	const SfxItemSet* pInSet = 0 );
//STRIP001 	SfxSingleTabDialog( Window* pParent, USHORT nUniqueId, const SfxItemSet* pInSet = 0 );
//STRIP001 #endif
//STRIP001 	virtual             ~SfxSingleTabDialog();
//STRIP001 
//STRIP001 	void				SetTabPage( SfxTabPage* pTabPage,
//STRIP001 									GetTabPageRanges pRangesFunc = 0 );
//STRIP001 	SfxTabPage*			GetTabPage() const { return pPage; }
//STRIP001 
//STRIP001 		// liefert ggf. per Map konvertierte lokale Slots
//STRIP001 	const USHORT*		GetInputRanges( const SfxItemPool& rPool );
//STRIP001 	void				SetInputSet( const SfxItemSet* pInSet )
//STRIP001 							{ pOptions = pInSet; }
//STRIP001 	const SfxItemSet*	GetOutputItemSet() const { return pOutSet; }
//STRIP001 	OKButton*			GetOKButton() const { return pOKBtn; }
//STRIP001 	CancelButton*		GetCancelButton() const { return pCancelBtn; }
//STRIP001 
//STRIP001 private:
//STRIP001 	SfxViewFrame*       pFrame;
//STRIP001 	GetTabPageRanges	fnGetRanges;	// Pointer auf die Ranges-Funktion
//STRIP001 	USHORT*				pRanges;
//STRIP001 
//STRIP001 	OKButton*			pOKBtn;
//STRIP001 	CancelButton*		pCancelBtn;
//STRIP001 	HelpButton*			pHelpBtn;
//STRIP001 #if SUPD < 637
//STRIP001 	void*				pDummy;
//STRIP001 #endif
//STRIP001 
//STRIP001 	SfxTabPage*			pPage;
//STRIP001 	const SfxItemSet*	pOptions;
//STRIP001 	SfxItemSet*			pOutSet;
//STRIP001 #if SUPD < 637
//STRIP001 	BOOL				bGrpBox;
//STRIP001 #endif
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( OKHdl_Impl, Button * );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif

